package ERROR;
use Exporter ();
@ISA = qw(Exporter);
@EXPORT = qw( error_m error_f error_w error_trimble new_log close_log error_i );

sub new_log {

  my $filename = shift;
  if (defined LOG) { close(LOG); }
  open( LOG, "+>>" . $filename ) or die "Could not open LOG $filename\n";

}

sub close_log {
  close(LOG);
}

sub error_trimble {

# This routine expects the $result variable used in Trimble_RFILE.pm 

 my $result = shift;

 $result = unpack( 'c', pack( 'C', ($result >> 8 )));

 %result_codes = (
	1 => "COULD_NOT_EXECUTE_RFILE",
	0 => "NO_ERROR",
	-4 => "PORT_ALLOCATION_ERROR",
	-5 => "MODEM_RESPONSE_ERROR",
	-6 => "MODEM_INIT_ERROR",
	-7 => "MODEM_FILE_ERROR",
	-8 => "MODEM_FILE_CREATION_ERROR",
	-9 => "COMM_INIT_ERROR",
	-10 => "SESSION_SETUP_ERROR",
	-11 => "INPUT_FILE_ERROR",
	-14 => "INPUT_ERROR",
	-15 => "INPUT_FILE_READ_ERROR",
	-16 => "COMM_TIMEOUT",
	-17 => "NAK_RECIEVED",
	-18 => "RCVR_FILE_ERROR",
	-19 => "DISK_FILE_OPEN_ERROR",
	-20 => "RCVR_FILE_RECORD_ERROR",
	-21 => "COMM_ERROR",
	-22 => "RETRIEVE_DIRECTORY_ERROR",
	-23 => "RCVR_CONFIG_ERROR",
	-24 => "CTRL_C_EXIT",
	-25 => "FILE_OPEN_ERROR",
	-26 => "FILE_DATA_ERROR",
	-27 => "COMM_ERROR_WHILE_PROGRAMMING",
	-28 => "FILE_READ_ERROR",
	-29 => "FILE_FORMAT_ERROR",
	-30 => "LOAD_MONITOR_ERROR",
	-31 => "FILE_AUTHORIZATION_ERROR",
	-32 => "SURVEY_NOT_STARTED",
	-33 => "RESET_REFUSED",
	-34 => "SYSTEM_BOOT_ERROR",
	-35 => "RECEIVER_IN_MONITOR",
	-36 => "HOST_NOT_AUTHORIZED",
	-37 => "FAST_FILE_XFER_ERROR",
	-38 => "SET_FLOW_CTRL_ERROR",
   );
 
# Comment this back in after testing
 if ($result == 0) { 
	error_m("RFILE Success ($result):$result_codes{$result}");
	return 0;
 }

 error_w("ERROR_T::Detected RFILE error ($result):$result_codes{$result}");

 return 1;

} 

sub error_m {
 
 my $mess = shift;
 if( $Trimble_DL'site{'error.screen'} eq "YES" && $Trimble_DL'site{'error.message'} eq "YES") {
	print STDOUT "MESSAGE::$mess\n";
 }
 if( $Trimble_DL'site{'error.message'} eq "YES") {
 	print LOG "MESSAGE::$mess\n";
 }
 if( !exists( $Trimble_DL'site{'error.message'} ) ) {
	print LOG "MESSAGE::$mess\n";
 }

}

sub error_f {
 
 my $mess = shift;
 if( $Trimble_DL'site{'error.fatal'} eq "YES" && $Trimble_DL'site{'error.screen'} eq "YES") {
	print STDOUT "FATAL_ERROR::$mess\n";
 }

 print LOG "FATAL_ERROR::$mess\n";
 die $mess;

}

sub error_w {

 my $mess = shift;
 if( $Trimble_DL'site{'error.warning'} eq "YES" && $Trimble_DL'site{'error.screen'} eq "YES") {
	print STDOUT "WARNING::$mess\n";
 }
 if( $Trimble_DL'site{'error.warning'} eq "YES") {
        print LOG "WARNING::$mess\n";
 }      
 if( !exists( $Trimble_DL'site{'error.warning'} ) ) {
        print LOG "WARNING::$mess\n";
 }

}

sub error_i {

 my $mess = shift;
 if( $Trimble_DL'site{'error.information'} eq "YES" && $Trimble_DL'site{'error.screen'} eq "YES") {
        print STDOUT "INFORMATION::$mess\n";
 }
 if( $Trimble_DL'site{'error.information'} eq "YES") {
	print LOG "INFORMATION::$mess\n";
 }
 if( !exists( $Trimble_DL'site{'error.information'} ) ) {
 	print LOG "INFORMATION::$mess\n";
 }

}

